import propsToAccessibilityComponent from "../propsToAccessibilityComponent.native.mjs";
describe("modules/AccessibilityUtil/propsToAccessibilityComponent", function () {
  test('when missing accessibility props"', function () {
    expect(propsToAccessibilityComponent({})).toBeUndefined();
  }), test('when "accessibilityRole" is "button"', function () {
    expect(propsToAccessibilityComponent({
      accessibilityRole: "button"
    })).toBeUndefined();
  }), test('when "accessibilityRole" is "heading"', function () {
    expect(propsToAccessibilityComponent({
      accessibilityRole: "heading"
    })).toEqual("h1");
  }), test('when "accessibilityRole" is "heading" and "aria-level" is set', function () {
    expect(propsToAccessibilityComponent({
      accessibilityRole: "heading",
      "aria-level": 3
    })).toEqual("h3");
  }), test('when "accessibilityRole" is "heading" and "accessibilityLevel" is set', function () {
    expect(propsToAccessibilityComponent({
      accessibilityRole: "heading",
      accessibilityLevel: 3
    })).toEqual("h3");
  }), test('when "accessibilityRole" is "label"', function () {
    expect(propsToAccessibilityComponent({
      accessibilityRole: "label"
    })).toEqual("label");
  });
});
//# sourceMappingURL=propsToAccessibilityComponent-test.native.mjs.map
