import { jsx as _jsx } from "react/jsx-runtime";
import React from "react";
import { isLocaleRTL } from "./isLocaleRTL.native.mjs";
var defaultLocale = {
    direction: "ltr",
    locale: "en-US"
  },
  LocaleContext = /* @__PURE__ */React.createContext(defaultLocale);
function getLocaleDirection(locale) {
  return isLocaleRTL(locale) ? "rtl" : "ltr";
}
function LocaleProvider(props) {
  var {
      direction,
      locale,
      children
    } = props,
    needsContext = direction || locale;
  return needsContext ? /* @__PURE__ */_jsx(LocaleContext.Provider, {
    value: {
      direction: locale ? getLocaleDirection(locale) : direction,
      locale
    },
    children
  }) : children;
}
function useLocaleContext() {
  return React.useContext(LocaleContext);
}
export { LocaleProvider, getLocaleDirection, useLocaleContext };
//# sourceMappingURL=index.native.mjs.map
